#!/usr/bin/python
##### Priblizno pravilo za skupino dveh anten - S53MV 15.2.2018 #####

import math,numpy	#uporabljene funkcije

def enakomerna(m,kh,fi,t):	#smerni diagram enakomerne skupine
	return abs(math.sin(m*(fi+kh*math.cos(t))/2)/math.sin((fi+kh*math.cos(t))/2))/m

def bocna(kh,t):		#smerni diagram bocne skupine
	return abs(math.cos(kh/2*math.cos(t)))

xk=[]		#polja za risanje kroga
yk=[]
x1=[]		#polja za risanje funkcije
y1=[]
x2=[]
y2=[]
x3=[]
y3=[]

k=0.01		#korak risanja v radianih

kh1=2*math.pi*1.5	#bocna skupina h=1.5*lambda

kh2=math.pi/2	#enakomerna skupina h=0.25*lambda, fi=-90stopinj
fi2=-math.pi/2*1.2
m=8		#stevilo elementov skupine

t=-math.pi+k/2		#kot theta v radianih
smax=0
while t<math.pi:
	xk=xk+[math.sin(t)]	#referencni enotni krog
	yk=yk+[math.cos(t)]
	s1=bocna(kh1,t)			#skupina #1
	x1=x1+[math.sin(t)*s1]
	y1=y1+[math.cos(t)*s1]
	s2=enakomerna(m,kh2,fi2,t-math.pi/2)	#skupina #2
	x2=x2+[math.sin(t)*s2]
	y2=y2+[math.cos(t)*s2]
	if smax<s2:		#poisci najvecjega
		smax=s2
	x3=x3+[math.sin(t)*s1*s2]	#zmnozek diagramov
	y3=y3+[math.cos(t)*s1*s2]
	t=t+k			#povecaj t za korak

x2=numpy.divide(x2,smax)	#normalizacija
y2=numpy.divide(y2,smax)
x3=numpy.divide(x3,smax)
y3=numpy.divide(y3,smax)

import matplotlib.pyplot as plt		#risanje grafa funkcije
plt.plot(xk,yk,'k-')		#referencni enotni krog
plt.plot([-1,1],[0,0],'k-')	#koordinatne osi
plt.plot([0,0],[-1,1],'k-')
plt.plot(x1,y1,'g-')		#risanje funkcij
plt.plot(x2,y2,'b-')
plt.plot(x3,y3,'r-')
plt.axis([-1.05,1.05,-1.05,1.05]) #okvir
plt.xticks([])
plt.yticks([])
plt.xlabel('Os z')
plt.ylabel('Ravnina xy')
plt.axes().set_aspect('equal')
plt.show()

#konec programa

