#!/usr/bin/python
##### Primerjava smernosti osne skupine dveh virov - S53MV 13.2.2018 #####

import math		#uporabljene funkcije
import matplotlib.pyplot as plt

def smernost(kh,fi):	#smernost osne skupine dveh virov
	return (1+math.cos(fi+kh))/(1+(math.sin(kh)/kh)*math.cos(fi))

def maxsmer(kh,r1,r2):	#poisci najvecjo smernost izmed stirih moznosti
	s=smernost(kh,math.asin(r1))
	if s<smernost(kh,math.pi-math.asin(r1)):
		s=smernost(kh,math.pi-math.asin(r1))
	if s<smernost(kh,math.asin(r2)):
		s=smernost(kh,math.asin(r2))
	if s<smernost(kh,math.pi-math.asin(r2)):
		s=smernost(kh,math.pi-math.asin(r2))
	return s

kkh=[]	#polja za risanje grafov
dd1=[]
dd2=[]
dd3=[]
dd4=[]

khkorak=0.01
kh=khkorak/2
while kh<5*math.pi:	#zanka po kh
	f1=-kh			#smernost za F(theta_max)=1, fi=-kh
	dd1=dd1+[smernost(kh,f1)]
	f2=math.pi+kh/3		#smernost za fi=pi+kh/3
	dd2=dd2+[smernost(kh,f2)]
	a=(math.sin(kh)/kh)**2-2*math.sin(kh)/kh*math.cos(kh)+1	#koeficienti kvadratne enacbe
	b=-2*(math.sin(kh))**2/kh*(math.sin(kh)/kh-math.cos(kh))
	c=(math.sin(kh)**4)/kh**2-(math.sin(kh))**2
	r1=(-b+math.sqrt(b**2-4*a*c))/(2*a)	#dve resitvi kvadratne enacbe
	r2=(-b-math.sqrt(b**2-4*a*c))/(2*a)
	dd3=dd3+[maxsmer(kh,r1,r2)]	#poisci najvecjo smernost izmed stirih moznosti
	f4=math.pi		#smernost zrcaljenja za fi=pi in D*2
	dd4=dd4+[2*smernost(kh,f4)]
	kkh=kkh+[kh/2/math.pi]		#povecaj kh za korak
	kh=kh+khkorak

plt.plot(kkh,dd1,'b-')	#risanje grafov
plt.plot(kkh,dd2,'g-')
plt.plot(kkh,dd3,'r-')
plt.plot(kkh,dd4,'m-')

plt.grid()
plt.title('Primerjava smernosti osne skupine dveh virov')
plt.xlabel(r'Razdalja h[$\lambda$]')
plt.ylabel('Smernost D(h)')
plt.show()

#konec programa

